#pragma once
#include "OpenGLRendererTrack.h"

#define	NAMEARRAYSIZE			(10)	// Ȏ傫
#define PICKREGIONOFFSET		(5)		// sbN̈̃ItZbg
#define PICKREGIONPIXELCOUNT	( 1 + 2 * PICKREGIONOFFSET ) * ( 1 + 2 * PICKREGIONOFFSET )	// sbN̈̃sNZ

// Render Mode
enum ERENDERMODE
{
	RM_UNDEFINED = 0,
	RM_RENDER,			// ʏ`
	RM_PICK_ELEMENTTYPE,// sbN`ivf^Cvj
	RM_PICK_ELEMENTID,	// sbN`ivfԍj
};

enum ERENDERELEMENTTYPE
{
	RET_UNDEFINED = 0,
	RET_POINT,
	RET_LINE,
	RET_FACE,
};

class COpenGLRendererPick :
	public COpenGLRendererTrack
{
public:
	COpenGLRendererPick();
	~COpenGLRendererPick();

	// oϐ
private:
	GLuint			m_uiTextureID;
	GLuint			m_uiRenderBufferID;
	GLuint			m_uiFrameBufferID;
	unsigned int	m_auiName_picked[NAMEARRAYSIZE];	// sbNꂽvf̖O

	// o֐
private:
	void	CreateFrameBuffer( int iWidth, int iHeight );
	void	DestroyFrameBuffer();
	bool	RenderScene();
	void	RenderModel( ERENDERMODE eRenderMode );
	void	IdentifyPickRegionPixels( unsigned int uiCountPickRegionPixel, unsigned int  aauiNamePickRegionPixel[][NAMEARRAYSIZE] );
public:
	void	UninitializeOpenGL( HWND hWnd );
	void	ChangeSize( HWND hWnd, int cx, int cy );
	int		DoPicking( int x, int y );
};

