#pragma once
#include "OpenGLRendererBase.h"

// TrackingMode
enum ETRACKINGMODE
{
	TM_NONE = 0,
	TM_ROTATION,
	TM_PAN,
	TM_ZOOM,
};

class COpenGLRendererTrack :
	public COpenGLRendererBase
{
public:
	COpenGLRendererTrack();
	~COpenGLRendererTrack();

	// oϐ
private:
	ETRACKINGMODE	m_eTrackingMode;
	POINT			m_ptLast;
	GLfloat			m_f3RenderingCenter[3];		// `撆S
	GLfloat			m_fRenderingRate;			// g嗦
	GLfloat			m_f16ViewingTransformMatrix[16];

	// o֐
private:
	bool	SetupProjectionMatrix();
	bool	SetupModelViewMatrix();
public:
	void	BeginTracking( HWND hWnd, POINT point, ETRACKINGMODE eTrackingMode );
	void	EndTracking();
	bool	DoTracking( POINT point );
};

